#include "interfaces/DatabaseConnection.h"
#include "interfaces/structs.h"
#include <array>
#include <iostream>
#include <pqxx/pqxx>
#include <sstream>
#include <string>
#include <vector>

int main() {
  try {
    DatabaseCredentials credentials{};
    credentials.user = "kiqadmin";
    credentials.password = "kiqadmin";
    credentials.name = "kiq";

    DatabaseConfiguration configuration{};
    configuration.credentials = credentials;
    configuration.address = "127.0.0.1";
    configuration.port = "5432";

    DatabaseConnection connection{};
    connection.setConfig(configuration);

    if (connection.connectToDatabase()) {
      std::cout << "Opened database successfully: " << connection.getDbName()
                << std::endl;
      // pqxx::work W(C);
      // pqxx::result R = W.exec("SELECT value from test");

      // for (auto row : R) {
      //   std::cout << row[0].c_str() << std::endl;
      // }
    } else {
      std::cout << "Can't open database" << std::endl;
      return 1;
    }
  } catch (const std::exception &e) {
    std::cerr << e.what() << std::endl;
    return 1;
  }

  return 0;
}
