#include "DatabaseConnection.h"
#include "structs.h"
#include <sstream>

DatabaseConnection::DatabaseConnection() {}

bool DatabaseConnection::isConnected() {
  return this->connected ? true : false;
}

bool DatabaseConnection::setConfig(DatabaseConfiguration config) {
  m_config = config;
  return true;
}

// std::string DatabaseConnection::getDbName(){return }

QueryResult DatabaseConnection::query(DatabaseQuery query) {
  switch (query.type) {
  case QueryType::INSERT: {
    std::stringstream query_stream{};

    query_stream << "INSERT INTO" << query.table << " VALUES (\"test\")";
    QueryResult result{};
    break;
  }
  case QueryType::DELETE:
    std::stringstream query_stream{};

    query_stream << "INSERT INTO" << query.table << " VALUES (\"test\")";
    QueryResult result{};
    return result;
  }
}

bool DatabaseConnection::connectToDatabase() {
  pqxx::connection C("dbname = kiq user = kiqadmin password = kiqadmin \
      hostaddr = 127.0.0.1 port = 5432");
  m_connection = std::move(&C);
}

std::string DatabaseConnection::getDbName() {
  return std::to_string(*m_connection->dbname());
}