#include "structs.h"
#include <pqxx/pqxx>

#ifndef DATABASECONNECTION_H
#define DATABASECONNECTION_H

class DatabaseConnection {
public:
  // constructor
  DatabaseConnection();
  // init db
  bool setConfig(DatabaseConfiguration config);
  bool connectToDatabase();
  // work
  QueryResult query(DatabaseQuery query);
  // state
  bool isConnected();
  std::string getDbName();

private:
  DatabaseConfiguration m_config;
  pqxx::connection *m_connection;
  bool connected;
};

#endif // DATABASECONNECTION_H